#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_ChildGeneralIdentify(EPM_action_message_t msg){
	printf("=========================判断子件属性是否为限用 Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//获取任务对象
	EPM_ask_root_task(msg.task, &rootTask);
	//获取任务目标对象
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	//获取参数
	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "";
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("参数个数为：%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//获取下一个参数（从0开始）
			arg = TC_next_argument(msg.arguments);
			//获取参数的名称和值
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if(stricmp(argflag, "itemType") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg1value, argvalue);
				}
			}
		}
		DOFREE(argflag);
		DOFREE(argvalue);
		DOFREE(arg);
	}

	vector<char *> itemTypeValues;

	if (strstr(arg1value, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(arg1value, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			itemTypeValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		itemTypeValues.push_back(arg1value);
	}

	char resultString[1024] = "";

	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s \r\n", itemType);
		//过滤掉非文件夹的对象
		if (!count(itemTypeValues, itemType))
		{
			DOFREE(itemType);
			continue;
		}
		int viewNum = 0;
		tag_t * viewTag = NULL_TAG;
		//判断是否包含BOM视图
		AOM_ask_value_tags(attachments[i], "structure_revisions", &viewNum, &viewTag);
		if (viewNum <= 0)
		{
			DOFREE(itemType);
			DOFREE(viewTag);
			continue;
		}
		//创建BOMWindow
		tag_t top_line = NULLTAG, window = NULLTAG;
		BOM_create_window(&window);
		//设置顶层BOM
		BOM_set_window_top_line(window, NULLTAG, attachments[i], NULLTAG, &top_line);

		int  count;
		tag_t *children_line = NULLTAG;

		BOM_line_ask_all_child_lines(top_line, &count, &children_line);

		for (int j = 0; j < count; j++)
		{

			tag_t revisions = NULLTAG;

			AOM_ask_value_tag(children_line[j], "bl_line_object", &revisions);

			tag_t item = NULLTAG;

			ITEM_ask_item_of_rev(revisions, &item);

			ITEM_ask_latest_rev(item, &revisions);

			char * generalIdentify = NULL;
			AOM_ask_value_string(item, "ml8_Status", &generalIdentify);
			
			char *itemString = NULL;

			AOM_ask_value_string(children_line[j], "bl_rev_object_string", &itemString);

			printf("限用：%s====================\n", generalIdentify);
			

			//if (generalIdentify != NULL && (strcmp(generalIdentify, "限用") == 0 || strcmp(generalIdentify, "冻结") == 0))			
			//if (generalIdentify != NULL && (strcmp(generalIdentify, "限用") == 0 || strcmp(generalIdentify, "冻结") == 0 || strcmp(generalIdentify, "RestrictPart") == 0 || strcmp(generalIdentify, "FreezePart") == 0))//添加BOM时限制添加冻结、限用物料处理步骤20230927
			if (generalIdentify != NULL && (strcmp(generalIdentify, "ObsoletePart") == 0 || strcmp(generalIdentify, "RestrictPart") == 0 || strcmp(generalIdentify, "FreezePart") == 0))//20250116海外要求增加废止状态
			{
				strcat(resultString, itemString);
				strcat(resultString, "\n");
				ifail = 1;
			}
			/*if (!IsRelease(children_line[j], resultString, referenceValues, releaseStatus))
			{
				ifail = 1;
			}*/
			DOFREE(generalIdentify);
			DOFREE(itemString);
		}

		BOM_close_window(window);
		DOFREE(itemType);
		DOFREE(children_line);

	}
	DOFREE(attachments);
	if (ifail == 1)
	{
		strcat(resultString, "属性为限用或冻结！");
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, resultString);
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_ChildGeneralIdentify用时:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_ChildGeneralIdentify用时:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================判断子件属性是否为限用 End====================\n");
	return ifail;
}